local CrystalMote = LibStub("AceAddon-3.0"):NewAddon("Broker_CrystalMote", "AceTimer-3.0")
local L = LibStub:GetLibrary("AceLocale-3.0"):GetLocale("Broker_CrystalMote")
local AC = LibStub("AceConfig-3.0")
local ACD = LibStub("AceConfigDialog-3.0")
local ACR = LibStub("AceConfigRegistry-3.0")
local ADO = LibStub("AceDBOptions-3.0")
local LTT = LibStub:GetLibrary("LibQTip-1.0")
local LDB = LibStub("LibDataBroker-1.1")
local MODNAME = "Broker CrystalMote"
local addon = CrystalMote
local version = GetAddOnMetadata("Broker_CrystalMote", "X-Version")
local author = GetAddOnMetadata("Broker_CrystalMote", "X-Author")
local builddate = GetAddOnMetadata("Broker_CrystalMote", "X-Build")
local tinsert, strformat = table.insert, string.format
local db, chardb, charsdb, tt, scale, updatetime, name, shortname, item, iconpath, icon, color, element, line, scroll, bank, inv
local modularOptions, charsList  = {}, {}
local GetItemCount, GetItemIcon = GetItemCount, GetItemIcon
local playerName = UnitName("player")
local charToPurge = "None"
local air = "99cccc"
local fire = "ff3300"
local life = "33cc00"
local mana = "33cccc"
local earth = "996600"
local water = "3399ff"
local shadow = "9933ff"
local might = "0066ff"
local nether = "ffcc00"
local vortex = "ff9900"
local orb = "3377aa"
local abyss = "338888"
local harmony = "526eff"
local hint = "00ff00"

local classColors = {}
for class, color in pairs(CUSTOM_CLASS_COLORS or RAID_CLASS_COLORS) do
    classColors[class] = strformat( "%2x%2x%2x", color.r * 255, color.g * 255, color.b * 255 )
end

if CUSTOM_CLASS_COLORS then
    CUSTOM_CLASS_COLORS:RegisterCallback(function()
        for class, color in pairs(CUSTOM_CLASS_COLORS) do
            classColors[class] = strformat("%2x%2x%2x", color.r * 255, color.g * 255, color.b * 255)
        end
        end)
end

local items = {
    ["bc"] = {22572, 22451, 22574, 21884, 22575, 21886, 22576, 22457, 22573, 22452, 22578, 21885, 22577, 22456, 23571, 23572, 30183, 22450},
    ["bcstrings"] = {L["Mote of Air"], L["Primal Air"], L["Mote of Fire"], L["Primal Fire"], L["Mote of Life"], L["Primal Life"], L["Mote of Mana"], L["Primal Mana"], L["Mote of Earth"], L["Primal Earth"], L["Mote of Water"], L["Primal Water"], L["Mote of Shadow"], L["Primal Shadow"], L["Primal Might"], L["Primal Nether"], L["Nether Vortex"], L["Void Crystal"]},
	["bcshort"] = {L["Short_Mote of Air"], L["Short_Primal Air"], L["Short_Mote of Fire"], L["Short_Primal Fire"], L["Short_Mote of Life"], L["Short_Primal Life"], L["Short_Mote of Mana"], L["Short_Primal Mana"], L["Short_Mote of Earth"], L["Short_Primal Earth"], L["Short_Mote of Water"], L["Short_Primal Water"], L["Short_Mote of Shadow"], L["Short_Primal Shadow"], L["Short_Primal Might"], L["Short_Primal Nether"], L["Short_Nether Vortex"], L["Short_Void Crystal"]},
    ["bccolors"] = {air, air, fire, fire, life, life, mana, mana, earth, earth, water, water, shadow, shadow, might, nether, vortex, abyss},
    ["lk"] = {37700, 35623, 37702, 36860, 37704, 35625, 37701, 35624, 37705, 35622, 37703, 35627, 43102, 34057},
    ["lkstrings"] = {L["Crystallized Air"], L["Eternal Air"], L["Crystallized Fire"], L["Eternal Fire"], L["Crystallized Life"], L["Eternal Life"], L["Crystallized Earth"], L["Eternal Earth"], L["Crystallized Water"], L["Eternal Water"], L["Crystallized Shadow"], L["Eternal Shadow"], L["Frozen Orb"], L["Abyss Crystal"]},
    ["lkshort"] = {L["Short_Crystallized Air"], L["Short_Eternal Air"], L["Short_Crystallized Fire"], L["Short_Eternal Fire"], L["Short_Crystallized Life"], L["Short_Eternal Life"], L["Short_Crystallized Earth"], L["Short_Eternal Earth"], L["Short_Crystallized Water"], L["Short_Eternal Water"], L["Short_Crystallized Shadow"], L["Short_Eternal Shadow"], L["Short_Frozen Orb"], L["Short_Abyss Crystal"]},
    ["lkcolors"] = {air, air, fire, fire, life, life, earth, earth, water, water, shadow, shadow, orb, abyss},
    ["cata"] = {52328, 52325, 52329, 52327, 52326, 52330, 52722},
    ["catastrings"] = {L["Volatile Air"], L["Volatile Fire"], L["Volatile Life"], L["Volatile Earth"], L["Volatile Water"], L["Volatile Shadow"], L["Maelstrom Crystal"]},
    ["catashort"] = {L["Short_Volatile Air"], L["Short_Volatile Fire"], L["Short_Volatile Life"], L["Short_Volatile Earth"], L["Short_Volatile Water"], L["Short_Volatile Shadow"], L["Short_Maelstrom Crystal"]},
    ["catacolors"] = {air, fire, life, earth, water, shadow, abyss},
    -- ["mop"] = {89112, 76061},
    -- ["mopstrings"] = {L["Mote of Harmony"], L["Spirit of Harmony"]},
    -- ["mopshort"] = {L["Short_Mote of Harmony"], L["Short_Spirit of Harmony"]},
    -- ["mopcolors"] = {harmony, harmony},	
    ["all"] = {},
    ["allstrings"] = {},
    ["allshort"] = {},
    ["allcolors"] = {}
}

for k,v in pairs (items.bc) do
    tinsert(items.all, v)
end
for k,v in pairs (items.bcstrings) do
    tinsert(items.allstrings, v)
end
for k,v in pairs (items.bcshort) do
    tinsert(items.allshort, v)
end
for k,v in pairs (items.bccolors) do
    tinsert(items.allcolors, v)
end
for k,v in pairs (items.lk) do
    tinsert(items.all, v)
end
for k,v in pairs (items.lkstrings) do
    tinsert(items.allstrings, v)
end
for k,v in pairs (items.lkshort) do
    tinsert(items.allshort, v)
end
for k,v in pairs (items.lkcolors) do
    tinsert(items.allcolors, v)
end
for k,v in pairs (items.cata) do
    tinsert(items.all, v)
end
for k,v in pairs (items.catastrings) do
    tinsert(items.allstrings, v)
end
for k,v in pairs (items.catashort) do
    tinsert(items.allstrings, v)
end
for k,v in pairs (items.catacolors) do
    tinsert(items.allcolors, v)
end
-- for k,v in pairs (items.mop) do
    -- tinsert(items.all, v)
-- end
-- for k,v in pairs (items.mopstrings) do
    -- tinsert(items.allstrings, v)
-- end
-- for k,v in pairs (items.mopshort) do
    -- tinsert(items.allstrings, v)
-- end
-- for k,v in pairs (items.mopcolors) do
    -- tinsert(items.allcolors, v)
-- end

local defaults = {
    profile = {
        showShort = true,
        showIcons = false,
        iconsOnly = false,
        tooltipIcons = false,
        tooltipIconsOnly = false,
        showZero = true,
        showBank = true,
        showAlts = true,
        showBC = true,
        showLK = true,
        showCATA = true,
        --showMOP = true,		
        showHint = true,
        updatetime = 5,
        scale = 1,
		scroll = 900,
    },
    realm = {
        chars = {
            ['*'] = {
                data = {
                    ['*'] = {inv = 0, bank = 0, track = false,},
                }
            }
        }
    }
}

local myFont = CreateFont("ToolTipFont")
myFont:SetFont(GameTooltipText:GetFont(), 12)

StaticPopupDialogs["CMFScale"] = {
    text = L["Scale Popup"],
    hasEditBox = 1,
    maxLetters = 3,
    OnShow = function(self)
        local editBox = self.editBox
        editBox:SetText(db.scale)
        editBox:HighlightText()
    end,
    EditBoxOnEnterPressed = function(self)
        local editBox = self:GetParent().editBox
        local input = editBox:GetText()
        scale = tonumber(input)
        if type(scale) == "number" then
            if scale <= 1.5 and scale >= .5 then
                addon:UpdateScale()
                self:GetParent():Hide()
            else
                self:GetParent():Hide()
                StaticPopup_Show ("CMFScale")
            end
        else
            self:GetParent():Hide()
            StaticPopup_Show ("CMFScale")
        end
    end,
    EditBoxOnEscapePressed = function(self)
        self:GetParent():Hide()
    end,
    timeout = 0,
    whileDead = 1,
    hideOnEscape = 1
}

StaticPopupDialogs["CMFTimer"] = {
    text = L["Update Popup"],
    hasEditBox = 1,
    maxLetters = 2,
    OnShow = function(self)
        local editBox = self.editBox
        editBox:SetText(db.updatetime)
        editBox:HighlightText()
    end,
    EditBoxOnEnterPressed = function(self)
        local editBox = self:GetParent().editBox
        local input = editBox:GetText()
        updatetime = tonumber(input)
        if type(updatetime) == "number" then
            if updatetime >= 1 and updatetime <= 30 and updatetime ~= 0 then
                addon:UpdateTimer()
                self:GetParent():Hide()
            else
                self:GetParent():Hide()
                StaticPopup_Show ("CMFTimer")
            end
        else
            self:GetParent():Hide()
            StaticPopup_Show ("CMFTimer")
        end
    end,
    EditBoxOnEscapePressed = function(self)
        self:GetParent():Hide()
    end,
    timeout = 0,
    whileDead = 1,
    hideOnEscape = 1
}

StaticPopupDialogs["CMFScroll"] = {
    text = L["Tooltip Scroll Height"],
    hasEditBox = 1,
    maxLetters = 3,
    OnShow = function(self)
        local editBox = self.editBox
        editBox:SetText(db.scroll)
        editBox:HighlightText()
    end,
    EditBoxOnEnterPressed = function(self)
        local editBox = self:GetParent().editBox
        local input = editBox:GetText()
        scroll = tonumber(input)
        if type(scroll) == "number" then
            if scroll >= 100 and scroll <= 900 and scroll ~= 0 then
                addon:UpdateScroll()
                self:GetParent():Hide()
            else
                self:GetParent():Hide()
                StaticPopup_Show ("CMFScroll")
            end
        else
            self:GetParent():Hide()
            StaticPopup_Show ("CMFScroll")
        end
    end,
    EditBoxOnEscapePressed = function(self)
        self:GetParent():Hide()
    end,
    timeout = 0,
    whileDead = 1,
    hideOnEscape = 1
}

StaticPopupDialogs["CMFPurge"] = {
    text = "",
    button1 = L["Ok"],
    button2 = L["Cancel"],
    OnAccept = function() addon:PurgeData(charToPurge) end,
    timeout = 0,
    whileDead = 1,
    hideOnEscape = 1
}

local function timerpopup()
    StaticPopup_Show ("CMFTimer")
end

local function scalepopup()
    StaticPopup_Show ("CMFScale")
end

local function scrollpopup()
    StaticPopup_Show ("CMFScroll")
end

local function charpurge()
    StaticPopup_Show ("CMFPurge")
end

local BCMDropDownMenu = CreateFrame("Frame", "BCMDropDownMenu")
BCMDropDownMenu.displayMode = "MENU"
BCMDropDownMenu.info = {}
BCMDropDownMenu.uncheck = function(dropdownbutton)
    _G[dropdownbutton:GetName().."Check"]:Hide()
end

local info = {}
BCMDropDownMenu.initialize = function(self, level)
    if not level then return end
    local info = self.info
    wipe(info)
    if level == 1 then
        info.isTitle      = 1
        info.text         = MODNAME
        info.notCheckable = 1
        UIDropDownMenu_AddButton(info, level)
        info.keepShownOnClick = 1
        info.isTitle      = nil
        info.text         = ""
        info.disabled     = 1
        UIDropDownMenu_AddButton(info, level)
        info.notCheckable = nil
        info.disabled     = nil
        info.text         = L["Include Zero Counts"]
        info.func         = function() db.showZero = not db.showZero addon:Update() end
        info.checked      = function() return db.showZero end
        UIDropDownMenu_AddButton(info, level)
        info.text         = L["Include Bank Counts"]
        info.func         = function() db.showBank = not db.showBank addon:Update() end
        info.checked      = function() return db.showBank end
        UIDropDownMenu_AddButton(info, level)
        info.text         = L["Include Alt Counts"]
        info.func         = function() db.showAlts = not db.showAlts addon:Update() end
        info.checked      = function() return db.showAlts end
        UIDropDownMenu_AddButton(info, level)
        info.checked      = nil
        info.notCheckable = 1
        info.text         = ""
        info.disabled     = 1
        UIDropDownMenu_AddButton(info, level)
        info.disabled     = nil
        info.hasArrow     = 1
        info.text         = L["Expansion Pack Select"]
        info.value        = "submenu1"
        info.func         = self.uncheck
        UIDropDownMenu_AddButton(info, level)
        info.text         = L["Tracking Options"]
        info.value        = "submenu2"
        UIDropDownMenu_AddButton(info, level)
        info.text         = L["Tooltip Options"]
        info.value        = "submenu3"
        UIDropDownMenu_AddButton(info, level)
        info.text         = L["Purge"]
        info.value        = "submenu4"
        UIDropDownMenu_AddButton(info, level)
        info.value        = nil
        info.hasArrow     = nil
        info.text         = ""
        info.disabled     = 1
        UIDropDownMenu_AddButton(info, level)
        info.disabled     = nil
        info.text         = L["Close"]
        info.func         = function() CloseDropDownMenus() end
        UIDropDownMenu_AddButton(info, level)
    elseif level == 2 then
        if UIDROPDOWNMENU_MENU_VALUE == "submenu1" then
            info.keepShownOnClick = 1
            info.text    = ("|cff00ff00"..L["The Burning Crusade"].."|r")
            info.func    = function() db.showBC = not db.showBC addon:Update() end
            info.checked = function() return db.showBC end
            UIDropDownMenu_AddButton(info, level)
            info.text    = ("|cff0066ff"..L["Wrath of the Lich King"].."|r")
            info.func    = function() db.showLK = not db.showLK addon:Update() end
            info.checked = function() return db.showLK end
            UIDropDownMenu_AddButton(info, level)
            info.text     = ("|cffff6600"..L["Cataclysm"].."|r")
            info.func    = function() db.showCATA = not db.showCATA addon:Update() end
            info.checked = function() return db.showCATA end
            UIDropDownMenu_AddButton(info, level)
            -- info.text     = ("|cff19ac87"..L["Mists of Pandaria"].."|r")
            -- info.func    = function() db.showMOP = not db.showMOP addon:Update() end
            -- info.checked = function() return db.showMOP end
            -- UIDropDownMenu_AddButton(info, level)			
        end
        if UIDROPDOWNMENU_MENU_VALUE == "submenu2" then
            info.keepShownOnClick = 1
            info.text    = L["Show Short Text"]
            info.func    = function() db.showShort = not db.showShort addon:Update() end
            info.checked = function() return db.showShort end
            UIDropDownMenu_AddButton(info, level)
            info.text    = L["Show Icons"]
            info.func    = function() db.showIcons = not db.showIcons addon:Update() end
            info.checked = function() return db.showIcons end
            UIDropDownMenu_AddButton(info, level)
            info.text    = L["Show Icons Only"]
            info.func    = function() db.iconsOnly = not db.iconsOnly addon:Update() end
            info.checked = function() return db.iconsOnly end
            UIDropDownMenu_AddButton(info, level)
            info.checked      = nil
            info.notCheckable = 1
            info.text         = ""
            info.disabled     = 1
            UIDropDownMenu_AddButton(info, level)
            info.disabled     = nil
            info.hasArrow     = 1
            info.text         = ("|cff00ff00"..L["The Burning Crusade"].."|r")
            info.value        = "submenu5"
            UIDropDownMenu_AddButton(info, level)
            info.text         = ("|cff0066ff"..L["Wrath of the Lich King"].."|r")
            info.value        = "submenu6"
            UIDropDownMenu_AddButton(info, level)
            info.text          = ("|cffff6600"..L["Cataclysm"].."|r")
            info.value         = "submenu7"
            UIDropDownMenu_AddButton(info, level)
            -- info.text          = ("|cff19ac87"..L["Mists of Pandaria"].."|r")
            -- info.value         = "submenu8"
            -- UIDropDownMenu_AddButton(info, level)			
        end
        if UIDROPDOWNMENU_MENU_VALUE == "submenu3" then
            info.keepShownOnClick = 1
            info.text    = L["Show icons in the tooltip."]
            info.func    = function() db.tooltipIcons = not db.tooltipIcons addon:Update() end
            info.checked = function() return db.tooltipIcons end
            UIDropDownMenu_AddButton(info, level)
            info.text    = L["Show icons only in the tooltip."]
            info.func    = function() db.tooltipIconsOnly = not db.tooltipIconsOnly addon:Update() end
            info.checked = function() return db.tooltipIconsOnly end
            UIDropDownMenu_AddButton(info, level)
            info.text    = L["Show hints in tooltip."]
            info.func    = function() db.showHint = not db.showHint addon:Update() end
            info.checked = function() return db.showHint end
            UIDropDownMenu_AddButton(info, level)
            info.checked      = nil
            info.notCheckable = 1
            info.text         = L["Tooltip Scale"]
            info.func         = scalepopup
            UIDropDownMenu_AddButton(info, level)
            info.text         = L["Tooltip Scroll Height"]
            info.func         = scrollpopup
            UIDropDownMenu_AddButton(info, level)
            info.text         = L["Update Time"]
            info.func         = timerpopup
            UIDropDownMenu_AddButton(info, level)
        end
        if UIDROPDOWNMENU_MENU_VALUE == "submenu4" then
            for name in pairs(charsdb) do
                info.text    = name
                info.func    = function() charToPurge = name StaticPopupDialogs["CMFPurge"].text = L["PurgePop"]..name..L["PurgePop2"] StaticPopup_Show("CMFPurge") end
                info.notCheckable = 1
                UIDropDownMenu_AddButton(info, level)
            end
        end
    elseif level == 3 then
        if UIDROPDOWNMENU_MENU_VALUE == "submenu5" then
            info.keepShownOnClick = 1
            for k,v in pairs (items.bc) do
                local name = items.bcstrings[k]
                local color = items.bccolors[k]
                item  = "|cff"..color..name.."|r"
                info.text    = item
                info.func    = function() chardb.data[name].track = not chardb.data[name].track addon:Update() end
                info.checked = function() return chardb.data[name].track end
                UIDropDownMenu_AddButton(info, level)
            end
        end
        if UIDROPDOWNMENU_MENU_VALUE == "submenu6" then
            info.keepShownOnClick = 1
            for k,v in pairs (items.lk) do
                local name = items.lkstrings[k]
                local color = items.lkcolors[k]
                item  = "|cff"..color..name.."|r"
                info.text    = item
                info.func    = function() chardb.data[name].track = not chardb.data[name].track addon:Update() end
                info.checked = function() return chardb.data[name].track end
                UIDropDownMenu_AddButton(info, level)
            end
        end
        if UIDROPDOWNMENU_MENU_VALUE == "submenu7" then
            info.keepShownOnClick = 1
            for k,v in pairs (items.cata) do
                local name = items.catastrings[k]
                local color = items.catacolors[k]
                item  = "|cff"..color..name.."|r"
                info.text     = item
                info.func    = function() chardb.data[name].track = not chardb.data[name].track addon:Update() end
                info.checked = function() return chardb.data[name].track end
                UIDropDownMenu_AddButton(info, level)
            end
        end
        -- if UIDROPDOWNMENU_MENU_VALUE == "submenu8" then
            -- info.keepShownOnClick = 1
            -- for k,v in pairs (items.mop) do
                -- local name = items.mopstrings[k]
                -- local color = items.mopcolors[k]
                -- item  = "|cff"..color..name.."|r"
                -- info.text     = item
                -- info.func    = function() chardb.data[name].track = not chardb.data[name].track addon:Update() end
                -- info.checked = function() return chardb.data[name].track end
                -- UIDropDownMenu_AddButton(info, level)
            -- end
        -- end		
    end
end

local options = nil
local function fullOptions()
    if (not options) then
        options = {
            type = "group",
            name = MODNAME,
            args = {
                general = {
                    order = 5,
                    type  = "group",
                    name  = L["General Information"],
                    args  = {
                        header1 = {
                            order = 10,
                            type  = "header",
                            name  = L["General Information"],
                        },
                        author = {
                            order = 20,
                            type  = "description",
                            name  = L["Author: "] .. author .. "\n",
                        },
                        version = {
                            order = 25,
                            type  = "description",
                            name  = L["Version: "] .. version .. "\n",
                        },
                        builddate = {
                            order = 30,
                            type  = "description",
                            name  = L["Build Date: "] .. builddate .. "\n",
                        },
                    },
                },
            },
        }
    end
    for k,v in pairs(modularOptions) do
        options.args[k] = (type(v) == "function") and v() or v
    end
    return options
end

local displayOptions = nil
local function giveDisplay()
    if (not displayOptions) then
            displayOptions = {
                order = 5,
                type = "group",
                name = L["Display Options"],
                args = {
           null = {
                order = 10,
                type  = "header",
                name  = L["Display Options"],
            },
            Zero = {
                type = "toggle",
                order = 15,
                name  = L["Include Zero Counts"],
                get   = function() return db.showZero end,
                set   = function() db.showZero = not db.showZero
                        addon:Update()
                        end,
            },
            Bank = {
                type = "toggle",
                order = 20,
                name  = L["Include Bank Counts"],
                get   = function() return db.showBank end,
                set   = function() db.showBank = not db.showBank
                        addon:Update()
                        end,
            },
            Alts = {
                type = "toggle",
                order = 25,
                name  = L["Include Alt Counts"],
                get   = function() return db.showAlts end,
                set   = function() db.showAlts = not db.showAlts
                        addon:Update()
                        end,
            },
           null1 = {
                order = 45,
                type  = "header",
                name  = L["Expansion Pack Select"],
            },
            bc = {
                type  = "toggle",
                order = 50,
                name  = ("|cff00ff00"..L["The Burning Crusade"].."|r"),
                get   = function() return db.showBC end,
                set   = function() db.showBC = not db.showBC
                        addon:Update()
                        end,
            },
            lk = {
                type  = "toggle",
                order = 55,
                name  = ("|cff0066ff"..L["Wrath of the Lich King"].."|r"),
                get   = function() return db.showLK end,
                set   = function() db.showLK = not db.showLK
                        addon:Update()
                        end,
            },
            cataclysm = {
                type  = "toggle",
                order = 57,
                name  = ("|cffff6600"..L["Cataclysm"].."|r"),
                get   = function() return db.showCATA end,
                set   = function() db.showCATA = not db.showCATA
                        addon:Update()
                        end,
            },
            -- mop = {
                -- type  = "toggle",
                -- order = 57,
                -- name  = ("|cff19ac87"..L["Mists of Pandaria"].."|r"),
                -- get   = function() return db.showMOP end,
                -- set   = function() db.showMOP = not db.showMOP
                        -- addon:Update()
                        -- end,
            -- },			
           null2 = {
                order = 63,
                type  = "header",
                name  = L["Tooltip Options"],
            },
            Scale = {
                order   = 65,
                type    = "range",
                name    = L["Tooltip Scale"],
                min     = .5,
                max     = 1.5,
                step    = .05,
                bigStep = .05,
                get     = function() return db.scale end,
                set     = function( info, v )
                          db.scale = v
                          tt:SetScale( v )
                          end,
            },
            Scroll= {
                order   = 67,
                type    = "range",
                name    = L["Tooltip Scroll Height"],
                min     = 100,
                max     = 900,
                step    = 25,
                bigStep = 25,
                get     = function() return db.scroll end,
                set     = function( info, v )
                          db.scroll = v
                          end,
            },
            Time = {
                order   = 70,
                type    = "range",
                name    = L["Update Time"],
                min     = 1,
                max     = 30,
                step    = 1,
                bigStep = 1,
                get     = function() return db.updatetime end,
                set     = function( info, v )
                          updatetime = v
                          addon:UpdateTimer()
                          end,
            },
           null3 = {
            order     = 75,
            type      = "description",
            name      = " ",
            cmdHidden = true
            },
            tooltipIcons = {
                type  = "toggle",
                order = 80,
                name  = L["Show icons in the tooltip."],
                width = "double",
                get   = function() return db.tooltipIcons end,
                set   = function() db.tooltipIcons = not db.tooltipIcons
                        addon:Update()
                        end,
            },
           null4 = {
            order     = 85,
            type      = "description",
            name      = " ",
            cmdHidden = true
            },
            tooltipIconsOnly = {
                type    = "toggle",
                order   = 90,
                name    = L["Show icons only in the tooltip."],
                width   = "double",
                get     = function() return db.tooltipIconsOnly end,
                set     = function() db.tooltipIconsOnly = not db.tooltipIconsOnly
                            addon:Update()
                            end,
                disabled = function() return not db.tooltipIcons end
            },
           null5 = {
            order     = 95,
            type      = "description",
            name      = " ",
            cmdHidden = true
            },
            showHint = {
                type  = "toggle",
                order = 100,
                name  = L["Show hints in tooltip."],
                width = "double",
                get   = function() return db.showHint end,
                set   = function() db.showHint = not db.showHint
                        addon:Update()
                        end,
            },
           null6 = {
                order = 110,
                type  = "header",
                name  = L["Purge"],
            },
            Purge = {
                type   = "select",
                order  = 115,
                name   = L["Purge"],
                set    = function(_, name) charToPurge = name StaticPopupDialogs["CMFPurge"].text = L["PurgePop"]..name..L["PurgePop2"] StaticPopup_Show("CMFPurge") end,
                values = charsList,
            },
        },
    }
    end
    return displayOptions
end

local trackOptions = nil
local function giveTrack()
    if (not trackOptions) then
            trackOptions = {
                order = 1,
                type = "group",
                name = L["Tracking Options"],
                args = {
           null = {
                order = 5,
                type  = "header",
                name  = L["Tracking Options"],
            },
            Tracker = {
                type  = "toggle",
                order = 10,
                name  = L["Show Short Text"],
                get   = function() return db.showShort end,
                set   = function() db.showShort = not db.showShort
                        addon:Update()
                        end,
            },
            Icons = {
                type = "toggle",
                order = 15,
                name  = L["Show Icons"],
                get   = function() return db.showIcons end,
                set   = function() db.showIcons = not db.showIcons
                        addon:Update()
                        end,
            },
            IconsOnly = {
                type = "toggle",
                order = 20,
                name  = L["Show Icons Only"],
                get   = function() return db.iconsOnly end,
                set   = function() db.iconsOnly = not db.iconsOnly
                        addon:Update()
                        end,
            },
           null0 = {
                order = 25,
                type  = "header",
                name  = "",
            },
        },
    }
		local trackerIndex = 30
		for k, v in pairs (items.all) do
			local name = items.allstrings[k]
			local color = items.allcolors[k]
			local item  = "|cff"..color..name.."|r"
			trackerIndex = trackerIndex  + 5
			trackOptions.args[name] = {
				type  = "toggle",
				name  = item,
				order = trackerIndex,
				get   = function() return chardb.data[name].track end,
				set   = function() chardb.data[name].track = not chardb.data[name].track
						addon:Update()
						end,
			}
		end
    end
    return trackOptions
end

local bcm = LDB:NewDataObject( MODNAME, {
    type  = "data source",
    text  = " ",
    label = MODNAME,
    icon  = "Interface\\AddOns\\Broker_CrystalMote\\icon",
    OnClick = function(self, button)
        if button == "RightButton" then
            ToggleDropDownMenu(1, nil, BCMDropDownMenu, "cursor")
        elseif
            button == "LeftButton" then
                addon:ShowTracking()
            if IsShiftKeyDown() then
                addon:ShowDisplay()
            end
        elseif
            button =="MiddleButton" then
				db.showHint = not db.showHint
        end
    end,
    OnEnter = function(self)
		tt = LTT:Acquire( MODNAME.."TT", 2, "LEFT", "CENTER")
		tt:SetFont(myFont)
		tt:SetScale(db.scale)
		addon:TooltipDraw()
		tt:SetAutoHideDelay( .1, self )
		tt:EnableMouse()
		tt:SmartAnchorTo(self)
		tt:UpdateScrolling(db.scroll)
        tt:Show()
    end,
    OnLeave = function(self)
    end,
} )

local function onTextUpdate()
    local tracktext = ""
    local textcount = 0
    for k, element in pairs(items.all) do
		iconpath = GetItemIcon(element)
        element = items.allstrings[k]
        color = items.allcolors[k]
        icon = "|T"..iconpath..":12:12:0:0:64:64:4:60:4:60|t"
        item  = "|cff"..color..element.."|r"
        if chardb.data[element].track then
            if chardb.data[element].track then
                textcount = textcount + 1
            else
                textcount = textcount - 1
            end
            if db.showShort then
                shortname = items.allshort[k]
                item = "|cff"..color..shortname.."|r"
            end
            if db.showIcons and not db.iconsOnly then
                item = icon..item
            elseif db.showIcons and db.iconsOnly then
                item = icon
            else
                item = item
            end
            if textcount == 1 then
                tracktext = tracktext.."- "..(item).." "..addon:Color(chardb.data[element].inv)
            else
                tracktext = tracktext.." | "..(item).." "..addon:Color(chardb.data[element].inv)
            end
        end
    end
    bcm.text = tracktext
end

function addon:OnInitialize()
    self.charName = playerName
    self.db = LibStub("AceDB-3.0"):New("Broker_CrystalMote_DB", defaults, true)
    self.db.RegisterCallback(self, "OnProfileChanged", "OnProfileChanged")
    self.db.RegisterCallback(self, "OnProfileCopied", "OnProfileChanged")
    self.db.RegisterCallback(self, "OnProfileReset", "OnProfileChanged")
    db = self.db.profile
    chardb = self.db.realm.chars[self.charName]
    charsdb = self.db.realm.chars
    if not chardb.class then
        chardb.class = strupper(select(2,UnitClass("player")))
    end
    for name in pairs(charsdb) do
        charsList[name] = name
    end
end

function addon:OnEnable()
    self.updateTimer = self:ScheduleRepeatingTimer("CountInv", db.updatetime)
    self:Update()
    self:SetupOptions()
end

function addon:OnDisable()
    self:CancelTimer(self.updateTimer)
end

function addon:SetupOptions()
    ACR:RegisterOptionsTable(MODNAME, fullOptions)
    self.optionsFrame = ACD:AddToBlizOptions(MODNAME, nil, nil, "general")
    self:RegisterModuleOptions("Display", giveDisplay(), L["Display Options"])
    self:RegisterModuleOptions("Tracking", giveTrack(), L["Tracking Options"])
    self:RegisterModuleOptions("Profiles", ADO:GetOptionsTable(self.db), "Profiles")
end

function addon:RegisterModuleOptions(name, optionsTable, displayName)
    modularOptions[name] = optionsTable
    self.optionsFrame[name] = ACD:AddToBlizOptions(MODNAME, displayName, MODNAME, name)
end

function addon:OnProfileChanged(event, database, newProfileKey)
    db = database.profile
    self:Update()
end

function addon:ShowTracking()
    InterfaceOptionsFrame_OpenToCategory(self.optionsFrame["Tracking"])
end

function addon:ShowDisplay()
    InterfaceOptionsFrame_OpenToCategory(self.optionsFrame["Display"])
end

function addon:PurgeData(name)
    self.db.realm[name] = nil
    charsdb[name] = nil
    ReloadUI()
end

function addon:UpdateScale()
    if scale ~= nil then
        db.scale = scale
    else
        scale = db.scale
    end
end

function addon:UpdateScroll()
    if scroll ~= nil then
        db.scroll = scroll
    else
        scroll = db.scroll
    end
end

function addon:UpdateTimer()
    if updatetime ~= nil then
        db.updatetime = updatetime
    else
        updatetime = db.updatetime
    end
    self:CancelTimer(self.updateTimer)
    self.updateTimer = self:ScheduleRepeatingTimer("CountInv", db.updatetime)
end

function addon:Update()
    onTextUpdate()
end

function addon:TooltipDraw()
	tt:Hide()
	tt:Clear()
	local y ,x, justification = tt:AddHeader(), 2, {}
	name = "|cff"..classColors[chardb.class]..self.charName.."|r"
	tt:SetCell(y, 2, name)
	tt:SetLineColor(1, .5, .5, .5, .1)
	tt:AddSeparator(2,1,1,1)
    if db.showAlts then
		for char, _ in pairs(charsdb) do
			tinsert(justification, "CENTER")
			if char ~= self.charName then
				x = x + 1
				tt:SetColumnLayout(x, "LEFT", "CENTER", unpack(justification))
				name = "|cff".. classColors[charsdb[char].class] .. char .. "|r"
				tt:SetCell(y, x, name)
			end
		end
    end
    if db.showBC then
		line = tt:GetLineCount()
        for k, element in pairs(items.bc) do
			iconpath = GetItemIcon(element)
            element = items.bcstrings[k]
            if db.showZero or self:CharHasElement(element) then
				line = line + 1
                color = items.bccolors[k]
                icon = "|T"..iconpath..":12:12:0:0:64:64:4:60:4:60|t"
                item  = "|cff"..color..element.."|r"
                if db.tooltipIcons and not db.tooltipIconsOnly then
                    item = icon .. " " .. item
                elseif db.tooltipIcons and db.tooltipIconsOnly then
                    item = icon
                else
                    item = item
                end
                tt:SetCell(tt:AddLine(), 1, item)
				char = self.charName
				tt:SetCell(line, 2, self:CountString(element, char ))
				tt:SetLineColor(line, 0,1,0,.1)
				x = 2
				if db.showAlts then
					for char, _ in pairs(charsdb) do
						if char ~= self.charName then
							x = x + 1
							tt:SetCell(line, x, self:CountString(element, char))
							tt:SetLineColor(line, 0,1,0,.1)
						end
					end
				end
            end
        end
    end
    if db.showLK  then
		line = tt:GetLineCount()
        for k, element in pairs(items.lk) do
			iconpath = GetItemIcon(element)
            element = items.lkstrings[k]
            if db.showZero or self:CharHasElement(element) then
				line = line + 1
                color = items.lkcolors[k]
                icon = "|T"..iconpath..":12:12:0:0:64:64:4:60:4:60|t"
                item  = "|cff"..color..element.."|r"
                if db.tooltipIcons and not db.tooltipIconsOnly then
                    item = icon .. " " .. item
                elseif db.tooltipIcons and db.tooltipIconsOnly then
                    item = icon
                else
                    item = item
                end
                tt:SetCell(tt:AddLine(), 1, item)
				char = self.charName
				tt:SetCell(line, 2, self:CountString(element, char ))
				tt:SetLineColor(line, 0,.1,1,.1)
				x = 2
				if db.showAlts then
					for char, _ in pairs(charsdb) do
						if char ~= self.charName then
							x = x + 1
							tt:SetCell(line, x, self:CountString(element, char))
							tt:SetLineColor(line, 0,.1,1,.1)
						end
					end
				end
            end
        end
    end
    if db.showCATA  then
		line = tt:GetLineCount()
        for k, element in pairs(items.cata) do
			iconpath = GetItemIcon(element)
            element = items.catastrings[k]
            if db.showZero or self:CharHasElement(element) then
				line = line + 1
                color = items.catacolors[k]
                icon = "|T"..iconpath..":12:12:0:0:64:64:4:60:4:60|t"
                item  = "|cff"..color..element.."|r"
                if db.tooltipIcons and not db.tooltipIconsOnly then
                    item = icon .. " " .. item
                elseif db.tooltipIcons and db.tooltipIconsOnly then
                    item = icon
                else
                    item = item
                end
                tt:SetCell(tt:AddLine(), 1, item)
				char = self.charName
				tt:SetCell(line, 2, self:CountString(element, char ))
				tt:SetLineColor(line, .9,.2,0,.1)
				x = 2
				if db.showAlts then
					for char, _ in pairs(charsdb) do
						if char ~= self.charName then
							x = x + 1
							tt:SetCell(line, x, self:CountString(element, char))
							tt:SetLineColor(line, .9,.2,0,.1)
						end
					end
				end
            end
        end
    end
    -- if db.showMOP  then
		-- line = tt:GetLineCount()
        -- for k, element in pairs(items.mop) do
			-- iconpath = GetItemIcon(element)
            -- element = items.mopstrings[k]
            -- if db.showZero or self:CharHasElement(element) then
				-- line = line + 1
                -- color = items.mopcolors[k]
                -- icon = "|T"..iconpath..":12:12:0:0:64:64:4:60:4:60|t"
                -- item  = "|cff"..color..element.."|r"
                -- if db.tooltipIcons and not db.tooltipIconsOnly then
                    -- item = icon .. " " .. item
                -- elseif db.tooltipIcons and db.tooltipIconsOnly then
                    -- item = icon
                -- else
                    -- item = item
                -- end
                -- tt:SetCell(tt:AddLine(), 1, item)
				-- char = self.charName
				-- tt:SetCell(line, 2, self:CountString(element, char ))
				-- tt:SetLineColor(line, .2,.8,.9,.1)
				-- x = 2
				-- if db.showAlts then
					-- for char, _ in pairs(charsdb) do
						-- if char ~= self.charName then
							-- x = x + 1
							-- tt:SetCell(line, x, self:CountString(element, char))
							-- tt:SetLineColor(line, .2,.8,.9,.1)
						-- end
					-- end
				-- end
            -- end
        -- end
    -- end	
	line = tt:GetLineCount()
	if db.showHint then
		tt:AddSeparator(2,1,1,1,1)
		tt:SetCell(tt:AddLine(), 1, "|cff"..hint..L["Right-click for Dropdown options menu."].."|r", x)
		tt:SetLineColor(line + 2, .5, .5, .5, .1)
		tt:SetCell(tt:AddLine(), 1, "|cff"..hint..L["Left-click for Tracking options panel."].."|r", x)
		tt:SetLineColor(line + 3, .5, .5, .5, .1)
		tt:SetCell(tt:AddLine(), 1, "|cff"..hint..L["Shift-Left-click for Display options panel."].."|r", x)
		tt:SetLineColor(line + 4, .5, .5, .5, .1)
		tt:SetCell(tt:AddLine(), 1, "|cff"..hint..L["Middle-click to show/hide the hints."].."|r", x)
		tt:SetLineColor(line + 5, .5, .5, .5, .1)
	end
end

function addon:CharHasElement(element)
    if chardb.data[element].inv > 0 or (db.showBank and chardb.data[element].bank > 0) then
        return true
    end
    if db.showAlts then
        for char, _ in pairs(charsdb) do
            if charsdb[char].data[element].inv > 0 or (db.showBank and charsdb[char].data[element].bank > 0) then
                return true
            end
        end
    end
    return false
end

function addon:CountString(element, char)
    return self:InvCountString(element, char)..self:BankCountString(element, char)
end

function addon:InvCountString(element, char)
    local tempChar = chardb
    if char then
        tempChar = charsdb[char]
    end
	return self:Color(tempChar.data[element].inv)
end

function addon:BankCountString(element, char)
    local tempChar = chardb
    if char then
        tempChar = charsdb[char]
    end
    if db.showBank then
        return " ("..self:Color(tempChar.data[element].bank)..")"
    else
        return " "
    end
end

function addon:CountInv()
    local data = chardb.data
    for k,v in pairs (items.all) do
        item = items.allstrings[k]
        inv = GetItemCount(v)
        bank = GetItemCount(v, true)
        bank = bank - inv
        data[item].inv = inv or 0
        data[item].bank = bank or 0
    end
	addon:Update()
end

function addon:Color(count)
	local perc = 0
	local max = 10
	if max ~= 0 then
		perc = count / max
	end
	local r1, g1, b1
	local r2, g2, b2
	if perc <= 0.5 then
		perc = perc * 2
		r1, g1, b1 = 1, 0, 0
		r2, g2, b2 = 1, 1, 0
	else
		perc = perc * 2 - 1
		r1, g1, b1 = 1, 1, 0
		r2, g2, b2 = 0, 1, 0
	end
	local r, g, b = r1 + (r2 - r1)*perc, g1 + (g2 - g1)*perc, b1 + (b2 - b1)*perc
	if r < 0 then
		r = 0
	elseif r > 1 then
		r = 1
	end
	if g < 0 then
		g = 0
	elseif g > 1 then
		g = 1
	end
	if b < 0 then
		b = 0
	elseif b > 1 then
		b = 1
	end
	r, g, b =  r * 255, g * 255, b * 255
	color = strformat("%02x%02x%02x", r, g, b)
	count = ("|cff"..color..count.."|r")
	return count
end